//+------------------------------------------------------------------+
//|                                              Sessions_Script.mq5 |
//|                                   Copyright 2013, Pasi Hakamaki. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Pasi Hakamaki."
#property link      "https://login.mql5.com/en/users/candles"
#property version   "1.1"
//+------------------------------------------------------------------+
//| Input parameters used to modify the line properties              |
//+------------------------------------------------------------------+
bool     DayStart            =true;
bool     UKOpen              =true;
bool     USOpen              =true;
string   TimeDayStart        ="02:00";         //Time Day Start hh:mm
string   TimeUKOpen          ="10:00";         //Time UK Open hh:mm
string   TimeUSOpen          ="16:30";         //Time US Open hh:mm
color    ClrDayStart         =clrSilver;
color    ClrUKOpen           =clrSilver;
color    ClrUSOpen           =clrSilver;
ENUM_LINE_STYLE StyleDayStart=STYLE_SOLID; /* Line style can be; */
ENUM_LINE_STYLE StyleUKOpen  =STYLE_DOT;   /* STYLE_SOLID,       */
ENUM_LINE_STYLE StyleUSOpen  =STYLE_DOT;   /* STYLE_DASH,        */
                                           /* STYLE_DOT,         */
                                           /* STYLE_DASHDOT,     */
                                           /* STYLE_DASHDOTDOT   */
//+------------------------------------------------------------------+
//| Global variables                                                 |
//+------------------------------------------------------------------+
datetime time_day_start;
datetime time_uk_open;
datetime time_us_open;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   MqlDateTime time;
   MqlRates    rates[];
   string day,next_day;
   string UK,next_uk;
   string US,next_us;
   TimeToStruct(TimeCurrent(),time);
   datetime time_current=TimeCurrent();
   string delim=" ";
   string time_day_start_string=TimeToString(time_current,TIME_DATE);
   string time_uk_open_string=TimeToString(time_current,TIME_DATE);
   string time_us_open_string=TimeToString(time_current,TIME_DATE);
   StringConcatenate(time_day_start_string,time_day_start_string,delim,TimeDayStart,":00");
   StringConcatenate(time_uk_open_string,time_uk_open_string,delim,TimeUKOpen,":00");
   StringConcatenate(time_us_open_string,time_us_open_string,delim,TimeUSOpen,":00");
   time_day_start=StringToTime(time_day_start_string);
   time_uk_open=StringToTime(time_uk_open_string);
   time_us_open=StringToTime(time_us_open_string);
   datetime next_day_start=time_day_start+86400;
   datetime next_uk_open=time_uk_open+86400;
   datetime next_us_open=time_us_open+86400;
   day="Day Start "+time_day_start_string;
   UK="UK Open "+time_uk_open_string;
   US="US Open "+time_us_open_string;
   next_day="Next Day Start "+string(next_day_start);
   next_uk="Next UK Open "+string(next_uk_open);
   next_us="Next US Open "+string(next_us_open);
   if(ObjectFind(0,day)==0)
     {
      ObjectDelete(0,day);
      ObjectDelete(0,next_day);
     }
   else if(DayStart)
     {
      ObjectCreate(0,day,OBJ_VLINE,0,time_day_start,0);
      ObjectSetInteger(0,day,OBJPROP_COLOR,ClrDayStart);
      ObjectSetInteger(0,day,OBJPROP_STYLE,StyleDayStart);
      ObjectSetInteger(0,day,OBJPROP_BACK,StyleDayStart,1);
      ObjectSetInteger(0,day,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                                OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                                OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                                OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                                OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                                OBJ_PERIOD_M30|OBJ_PERIOD_H1);
      ObjectCreate(0,next_day,OBJ_VLINE,0,next_day_start,0);
      ObjectSetInteger(0,next_day,OBJPROP_COLOR,ClrDayStart);
      ObjectSetInteger(0,next_day,OBJPROP_STYLE,StyleDayStart);
      ObjectSetInteger(0,next_day,OBJPROP_BACK,StyleDayStart,1);
      ObjectSetInteger(0,next_day,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                                     OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                                     OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                                     OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                                     OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                                     OBJ_PERIOD_M30|OBJ_PERIOD_H1);
     }
   if(ObjectFind(0,UK)==0)
     {
      ObjectDelete(0,UK);
      ObjectDelete(0,next_uk);
     }
   else if(UKOpen)
     {
      ObjectCreate(0,UK,OBJ_VLINE,0,time_uk_open,0);
      ObjectSetInteger(0,UK,OBJPROP_COLOR,ClrUKOpen);
      ObjectSetInteger(0,UK,OBJPROP_STYLE,StyleUKOpen);
      ObjectSetInteger(0,UK,OBJPROP_BACK,StyleUKOpen,1);
      ObjectSetInteger(0,UK,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                               OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                               OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                               OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                               OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                               OBJ_PERIOD_M30|OBJ_PERIOD_H1);
      ObjectCreate(0,next_uk,OBJ_VLINE,0,next_uk_open,0);
      ObjectSetInteger(0,next_uk,OBJPROP_COLOR,ClrUKOpen);
      ObjectSetInteger(0,next_uk,OBJPROP_STYLE,StyleUKOpen);
      ObjectSetInteger(0,next_uk,OBJPROP_BACK,StyleUKOpen,1);
      ObjectSetInteger(0,next_uk,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                                    OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                                    OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                                    OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                                    OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                                    OBJ_PERIOD_M30|OBJ_PERIOD_H1);
     }
   if(ObjectFind(0,US)==0)
     {
      ObjectDelete(0,US);
      ObjectDelete(0,next_us);
     }
   else if(USOpen)
     {
      ObjectCreate(0,US,OBJ_VLINE,0,time_us_open,0);
      ObjectSetInteger(0,US,OBJPROP_COLOR,ClrUSOpen);
      ObjectSetInteger(0,US,OBJPROP_STYLE,StyleUSOpen);
      ObjectSetInteger(0,US,OBJPROP_BACK,StyleUSOpen,1);
      ObjectSetInteger(0,US,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                               OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                               OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                               OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                               OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                               OBJ_PERIOD_M30|OBJ_PERIOD_H1);
      ObjectCreate(0,next_us,OBJ_VLINE,0,next_us_open,0);
      ObjectSetInteger(0,next_us,OBJPROP_COLOR,ClrUSOpen);
      ObjectSetInteger(0,next_us,OBJPROP_STYLE,StyleUSOpen);
      ObjectSetInteger(0,next_us,OBJPROP_BACK,StyleUSOpen,1);
      ObjectSetInteger(0,next_us,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                                    OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                                    OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                                    OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                                    OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                                    OBJ_PERIOD_M30|OBJ_PERIOD_H1);
     }
   remove_history();
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+
void fill_history(datetime current_day,datetime current_uk,datetime current_us)
  {
   string history_name_start="Past "+string(current_day-86400);
   string history_name_uk="Past "+string(current_uk-86400);
   string history_name_us="Past "+string(current_us-86400);
   datetime history_time_start=current_day-86400;
   datetime history_time_uk=current_uk-86400;
   datetime history_time_us=current_us-86400;
   for(int i=0;i<365;i++)
     {
      if(DayStart)
        {
         ObjectCreate(0,history_name_start,OBJ_VLINE,0,history_time_start,0);
         ObjectSetInteger(0,history_name_start,OBJPROP_COLOR,ClrDayStart);
         ObjectSetInteger(0,history_name_start,OBJPROP_STYLE,StyleDayStart);
         ObjectSetInteger(0,history_name_start,OBJPROP_BACK,StyleDayStart,1);
         ObjectSetInteger(0,history_name_start,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                                                  OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                                                  OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                                                  OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                                                  OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                                                  OBJ_PERIOD_M30|OBJ_PERIOD_H1);
         history_time_start-=86400;
         history_name_start="Past "+string(history_time_start);
        }
      if(UKOpen)
        {
         ObjectCreate(0,history_name_uk,OBJ_VLINE,0,history_time_uk,0);
         ObjectSetInteger(0,history_name_uk,OBJPROP_COLOR,ClrUKOpen);
         ObjectSetInteger(0,history_name_uk,OBJPROP_STYLE,StyleUKOpen);
         ObjectSetInteger(0,history_name_uk,OBJPROP_BACK,StyleUKOpen,1);
         ObjectSetInteger(0,history_name_uk,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                                               OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                                               OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                                               OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                                               OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                                               OBJ_PERIOD_M30|OBJ_PERIOD_H1);
         history_time_uk-=86400;
         history_name_uk="Past "+string(history_time_uk);
        }
      if(USOpen)
        {
         ObjectCreate(0,history_name_us,OBJ_VLINE,0,history_time_us,0);
         ObjectSetInteger(0,history_name_us,OBJPROP_COLOR,ClrUSOpen);
         ObjectSetInteger(0,history_name_us,OBJPROP_STYLE,StyleUSOpen);
         ObjectSetInteger(0,history_name_us,OBJPROP_BACK,StyleUSOpen,1);
         ObjectSetInteger(0,history_name_us,OBJPROP_TIMEFRAMES,OBJ_PERIOD_M1|OBJ_PERIOD_M2|
                                                               OBJ_PERIOD_M3|OBJ_PERIOD_M4|
                                                               OBJ_PERIOD_M5|OBJ_PERIOD_M6|
                                                               OBJ_PERIOD_M10|OBJ_PERIOD_M12|
                                                               OBJ_PERIOD_M15|OBJ_PERIOD_M20|
                                                               OBJ_PERIOD_M30|OBJ_PERIOD_H1);
         history_time_us-=86400;
         history_name_us="Past "+string(history_time_us);
        }
     }
  }
//+------------------------------------------------------------------+
bool remove_history()
  {
   bool found=false;
   int total_objects=ObjectsTotal(0,0,OBJ_VLINE);
   if(total_objects==0)
     {
      return false;
     }
   for(int i=total_objects-1;i>=0;i--)
     {
      string name=ObjectName(0,i,0,OBJ_VLINE);
      if(StringFind(name,"Past ",0)!=-1)
        {
         ObjectDelete(0,name);
         found=true;
        }
     }
   if(!found)
     {
      fill_history(time_day_start,time_uk_open,time_us_open);
      return true;
     }
   return false;
  }
//+------------------------------------------------------------------+